/* IMPLEMENTACION DEL MODULO DE LISTADOS */
#include <stdio.h>
#include <conio.h>
#include "listados.h"
#include "articulos.h"

/* VARIABLE PRIVADA */
static TipoArticulo RARTICULO;

/* FUNCIONES PRIVADAS */
/*****************************************************************************/
/* Borra las 15 lineas que se imprimen en pantalla para los listado 			  */
/*****************************************************************************/

static void  borra_listado(void)
{
int i;
for(i=0; i<15; i++)
{
gotoxy(1,(7+i)); clreol();
}
}
/*****************************************************************************/
/* Comprueba cuantas lienas llevamos imprimidas y devuleve 0(cero)           */
/*	 si hemos llegado al tope de lineas que podemos imprimir por pagina		  */
/*****************************************************************************/

static int comprueba_lineas(int linea)
{
  if(linea>14)
   {
    getch();
    borra_listado();
    linea=0;
    gotoxy(1,7);
   }
return (linea);
}

/* FUNCIONE PUBLICAS */
/* ---------------------------------------------------------------*/
/* Inventario Total valorado del almacen*/
/* ---------------------------------------------------------------*/
void List_Total ( FILE *fent )
{
   int linea=0;
   short grupo_aux;
   long subtotal=0, totalalmacen=0 ;
   clrscr();
   gotoxy(1,2);
   puts("                        INVENTARIO DE ALMACEN");
   puts("=========================================================================");
   puts("GRUPO  CODIGO DESCRIPCION                    STOCK    PCOMPRA      TOTAL");
   puts("=========================================================================");
   gotoxy(1,7);
   fseek(fent,0L,SEEK_SET);
   fread(&RARTICULO,sizeof(RARTICULO),1,fent);

   while ( !feof(fent) )
      {
      grupo_aux = RARTICULO.grupo;
      if(grupo_aux!=0)        //si el registro no esta eliminado imprimo
	       {
   	    printf("%3d:\n", RARTICULO.grupo);
  		     linea++;
   	    linea=comprueba_lineas(linea);
   	    }
          //mientras sea el mismo grupo y no sea final de fichero
      while ((grupo_aux==RARTICULO.grupo) && !feof(fent))
       {
        if(RARTICULO.grupo!=0) //si no esta eliminado imprimo
           {
      		printf("       %-6s %-30s %4d     %6d   %8d\n",RARTICULO.codigo,
      		RARTICULO.descripcion, RARTICULO.stock,RARTICULO.precioc,
            	((RARTICULO.stock*RARTICULO.precioc)));
          	subtotal=subtotal+(RARTICULO.stock*RARTICULO.precioc);
            linea++;
            linea=comprueba_lineas(linea);
           }

        fread(&RARTICULO,sizeof(RARTICULO),1,fent);
       }
       if(grupo_aux!=0)
        {
         printf("\t\t\t\t\t        SUBTOTAL GRUPO = %6d\n", subtotal);
         totalalmacen=totalalmacen+subtotal;
         subtotal=0;
         linea++;
         linea=comprueba_lineas(linea);
        }
      }

      puts("=======================================================================");
      printf("\t\t\t\t\t         TOTAL ALMACEN = %6d\n", totalalmacen);
      getch();


}
/*****************************************************************************/
/* Listado de los productos por debajo del stock minimo 							  */
/*****************************************************************************/
void List_Stock_Minimo( FILE *fent )
{
   int linea=0;


   clrscr();
   gotoxy(1,2);
   printf("            ARTICULOS CON STOCK MINIMO\n\n");
   printf("======================================================================\n");
   printf("CODIGO DESCRIPCION                   GRUPO  STOCK-ACTUAL  STOCK-MINIMO\n");
   printf("======================================================================\n");
   gotoxy(1, 22);
   printf("======================================================================\n");
   gotoxy(1,7);
   fseek(fent,0L,SEEK_SET);
   fread(&RARTICULO,sizeof(RARTICULO),1,fent);

   while ( !feof(fent) )
   {                //comparo si es menor al stock minimo o si no esta eliminado
    if ((RARTICULO.stock<RARTICULO.stockmin) && (RARTICULO.grupo !=0))
    	{
       if (linea==15) //si hemos llenado la pantalla paramos y borramos
       	{
             getch();
             borra_listado();
             linea=0;
             gotoxy(1,7);
         }
      		printf("%-6s %-30s  %4d      %6d      %6d\n",RARTICULO.codigo,
      		RARTICULO.descripcion, RARTICULO.grupo,RARTICULO.stock,
            RARTICULO.stockmin);
            linea++;
            linea=comprueba_lineas(linea);
       }
     fread(&RARTICULO,sizeof(RARTICULO),1,fent);
   }
    getch();


}

/*****************************************************************************/
/* Listado de Ventas Mensuales															 */
/*****************************************************************************/

void List_Venta_Mensual(FILE *fent)
{
   int linea=0, i;
   long subtotal;
   short grupo_aux;
   int tablaventas[12]={0,0,0,0,0,0,0,0,0,0,0,0};


   clrscr();
   gotoxy(1,2);
   printf("            VENTAS MENSUALES POR GRUPO\n\n");
   printf("=======================================================================\n");
   printf("GRUPO ENE. FEB. MAR. ABR. MAY. JUN. JUL. AGO. SEP. OCT. NOV. DIC. TOTAL\n");
   printf("=======================================================================\n");
   gotoxy(1, 22);
   printf("=======================================================================\n");
   gotoxy(1,7);
   fseek(fent,0L,SEEK_SET);
   fread(&RARTICULO,sizeof(RARTICULO),1,fent);

   while ( !feof(fent) )
   {
     grupo_aux=RARTICULO.grupo;
     if(grupo_aux!=0)
     {
      // inicializo la tabla de ventas en cada grupo a cero
      for(i=0;i<12;i++)
      	{
         tablaventas[i]=0;
         }
           	subtotal=0;
      while ((RARTICULO.grupo==grupo_aux) && !feof(fent))
      {

         //bucle de las ventas del mes de cada registro
	      for(i=0; i<12; i++)
	      {
           //acumulo las ventas de cada mes
	       tablaventas[i]=+RARTICULO.ventasmes[i];
          subtotal=subtotal+tablaventas[i]; //Total acumulado
	      }
	       fread(&RARTICULO,sizeof(RARTICULO),1,fent);
      }
      gotoxy(1,(7+linea));
      printf ("  %6d ", grupo_aux);
      for(i=0;i<12;i++)
	     {
 	     gotoxy(7+(i*5),(7+linea));printf("%6d", tablaventas[i]);
		  }
      gotoxy(67,7+linea);printf("%6d\n", subtotal);
      linea++;
     }
     else
     {
      fread(&RARTICULO,sizeof(RARTICULO),1,fent);
     }
   }
    getch();
}
/*****************************************************************************/
/* Listado de los 10 articulos mas vendidos Junio, Julio y Agosto            */
/*****************************************************************************/

void List_Periodo_Estival(FILE *fent)
{
	long subtotal,posicion;
	long  tablaestival[10][2]; // 0, posicion, 1, total venta estival
   int i, j;
   clrscr();
   gotoxy(1,2);
   printf("            ARTICULOS CON MAXIMAS VENTAS PERIODO ESTIVAL\n\n");
   printf("=======================================================================\n");
   printf("CODIGO DESCRIPCIN            GRUPO P.VENTA P.COMPRA JUNIO JULIO AGOSTO\n");
   printf("=======================================================================\n");
   gotoxy(1, 22);
   printf("=======================================================================\n");
   gotoxy(1,7);

   for (i=0; i<10; i++)
   {
    tablaestival[i][0]=0;
    tablaestival[i][1]=0;
   }
   posicion=0;
   fseek(fent,(posicion*sizeof(RARTICULO)),SEEK_SET);
   fread(&RARTICULO,sizeof(RARTICULO),1,fent);

   while ( !feof(fent) )
   {
    //acumulo el total de los tres meses para el articulo
    subtotal=RARTICULO.ventasmes[5]+RARTICULO.ventasmes[6]+RARTICULO.ventasmes[7];
    i=0;
    //Busco si en la tabla tengo alguno menor
    while (subtotal<tablaestival[i][1])
     {
      i++;
     }
     if(i<10)
      {
      //si tengo alguno menor muevo toda la tabla una posicion y lo inserto
        if (subtotal>tablaestival[i][1])
        	{
           for(j=9;j>(i+1);j--)
           	{
             tablaestival[j-1][0]=tablaestival[j][0];
             tablaestival[j-1][1]=tablaestival[j][1];
            }
             tablaestival[i][0]=posicion;
             tablaestival[i][1]=subtotal;
         }

      }
     posicion++;
     fseek(fent,(posicion*sizeof(RARTICULO)),SEEK_SET);
     fread(&RARTICULO,sizeof(RARTICULO),1,fent);
   }
   fseek(fent,0L,SEEK_SET);
   i=0;
   while((tablaestival[i][1]!=0) &&  (i<10))
   {
    // Posciono el fichero en la poscion almacenada en la tabla y leo
    fseek(fent,(tablaestival[i][0]*sizeof(RARTICULO)),SEEK_SET);
    fread(&RARTICULO,sizeof(RARTICULO),1,fent);
    printf("%6s %-24.24s %3d %5d  %5d   %5d  %5d %5d\n", RARTICULO.codigo,RARTICULO.descripcion,
    RARTICULO.grupo,RARTICULO.preciov, RARTICULO.precioc,
    RARTICULO.ventasmes[5],RARTICULO.ventasmes[6],RARTICULO.ventasmes[7]);
    i++;
   }
   getch();
}
