/* ------------------------------------------------------ *
   MODULO: MANARTICULOS.C
   MANTENIMIENTO DE UN FICHERO DIRECTO

   Autor: Alumnos de 1 DAI ( Tarde ) & Profesor

   Versin : 1.0 ( MODULAR )
   Fecha del ltimo cambio: 22/04/2005

 * EJEMPLO DE MANTENIMIENTO DE UN FICHERO DE ARTICULOS

 * Controlado por un menu:

  - Opciones de movimiento:

  Siguiente : Muestra el siguiente registro
  Anterior  : Muestra el anterior
  Otro      : Muestra un registro concreto a partir de su posicin
  Primero   : Muestra el primer registro
  Ultimo    : Muestra el ltimo
  Buscar    : Busca un cdigo de articulo utilizando una tabla ndices

  - Opciones de Acciones

  Nuevo     : Graba al final un nuevo registro
  Modificar : Modifica el registro actual
  Eliminar  : Realiza un borrado lgico marcando el registro
  Venta     : Anota los datos relativos a la venta del articulo actual
  Compra    : Anota los datos relativos a la compra de acticulo actual

  POSIBLES MEJORAS:

  1) Borrado fsico de los registros marcados al salir del programa
  2) Mantener una lista de registro borrados para utilizar su espacio
     cuando aadimos nuevos registros
  3) Incluir la tabla de indices en la estructura del fichero
  4) Permitir varias tablas de indices dinmicas
  5) Mejora general de la presentacin y de la validacin de los datos
  6) Utilizar la liberia curses para portar sobre UNIX/LINUX

 * ------------------------------------------------------ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>

#include "articulos.h"     // Include local con la estructura del tipo articulo
#include "idxarticulos.h"  // Manejo del Indice
#include "io_util.h"       // Utilidades de E/S por pantalla
#include "listados.h"      // Funciones de listados


#define  ESTA_BORRADO(R)  ( R.grupo == 0)
#define  POR_BORRADO(R)   ( R.grupo = 0 )

/* Variables Globables */
TipoArticulo  RArticulo;  /*   Registro donde leo o escribo  */
FILE *	fent;            /*   Puntero a estructura Fichero       */

/* --------------------------------------------------- */
/* Definicin de Funciones del Modulo : MANARTI.C :    */
/* --------------------------------------------------- */

/* FUNCIONES DE DESPLAZAMIENTO POR EL FICHERO */

void Siguiente( void );
void Anterior ( void );
void Primero  ( void );
void Ultimo   ( void );
void Otro     ( void );
void Buscar   ( void );

/* FUNCIONES DE ACCION QUE MODIFICAN EL CONTENIDO DEL FICHERO */

void Nuevo  ( void );
void Compra ( void );
void Venta  ( void );
void Modificar ( void );
void Eliminar  ( void );
void Listados  ( void );

/* FUNCIONES AUXILIARES */


void VerMenu      ( void );
void VerMenulistados ( void );
void VerCampos    ( void );
void VerError     ( char *msg );
void ObtenerFecha (int x, int y, Tfecha *f, short mostrar );

/* -----------------------------------------*/
/*     Muestra un Mensaje de error          */
/* -----------------------------------------*/
void VerError ( char *msg )
{
 textcolor(RED+BLINK);
 gotoxy(25,20); cputs( msg ); ungetch(getch());
 textcolor(WHITE);
 gotoxy(25,20); clreol();

}


/* ---------------------------------------------------------------*/
/* MUESTRA UNA LINEA DE MENUS CON LAS LETRAS INICIALES ILUMINADAS */
/* ---------------------------------------------------------------*/
void VerMenu ( void )
{
  textcolor(10);
  gotoxy  (6,2); cputs("____________________________________________  ");
  gotoxy  (6,3); cputs("                                           ");
  gotoxy  (6,4); cputs("A R C H I V O    D E    A R T I C U L O S  ");
  gotoxy  (6,5); cputs("____________________________________________  ");
  textcolor(6);
  gotoxy (5,22);
  cprintf ("N");         highvideo();
  cprintf ("uevo ");     lowvideo();
  cprintf ("E");         highvideo();
  cprintf ("liminar ");  lowvideo();
  cprintf ("M");         highvideo();
  cprintf ("odificar "); lowvideo();
  cprintf ("V");         highvideo();
  cprintf ("enta ");     lowvideo();
  cprintf ("C");         highvideo();
  cprintf ("ompra ");    lowvideo();
  cprintf ("L");         highvideo();
  cprintf ("istados ");  lowvideo();
  cprintf ("T");         highvideo();
  cprintf ("erminar ");  lowvideo();
  textcolor(9);
  gotoxy (5,24);

  cprintf ("S");         highvideo();
  cprintf ("iguiente "); lowvideo();
  cprintf ("A");         highvideo();
  cprintf ("nterior ");  lowvideo();
  cprintf ("P");         highvideo();
  cprintf ("rimero ");   lowvideo();
  cprintf ("U");         highvideo();
  cprintf ("ltimo ");    lowvideo();
  cprintf ("O");         highvideo();
  cprintf ("tro ");      lowvideo();
  cprintf ("B");         highvideo();
  cprintf ("uscar :");   lowvideo();
}

/* ---------------------------------------------------------------*/
/* MUESTRA UNA LINEA DE MENUS CON LAS LETRAS INICIALES ILUMINADAS */
/* PARA EL MENU DE LOS LISTADOS DE IMPRESION 							  */
/* ---------------------------------------------------------------*/
void VerMenuListados( void )
{

  textcolor(BLUE);
  gotoxy  (20,1); cputs("=== L I S T A D O S   D E   A L M A C E N ===");
  gotoxy (5,24);
  cprintf ("I");         highvideo();
  cprintf ("ventario "); lowvideo();
  cprintf ("S");         highvideo();
  cprintf ("tock_Minimo ");  lowvideo();
  cprintf ("V");         highvideo();
  cprintf ("entas_Mensuales ");highvideo();
  cprintf ("Ventas_");lowvideo();
  cprintf ("E");      highvideo();
  cprintf ("stivales ");lowvideo();
  cprintf ("T");         highvideo();
  cprintf ("erminar :"); normvideo();
  textcolor(WHITE);
}


/* ---------------------------------------------------------------*/
/* Muestra por pantalla la informacin de un registro o CAMPOS    */
/* ---------------------------------------------------------------*/
void VerCampos ( void )
{
  textcolor(GREEN);
  gotoxy(15, 7); cprintf(" N Reg :"); clreol();
  textcolor(14); cprintf("%5d",ftell(fent)/sizeof(RArticulo));
  textcolor(DARKGRAY);
  gotoxy(24, 8);clreol();
  gotoxy(24,10);clreol();
  gotoxy(24,11);clreol();
  gotoxy(29,12);clreol();
  gotoxy(29,13);clreol();
  gotoxy(27,14);clreol();
  gotoxy(27,15);clreol();
  gotoxy(27,16);clreol();
  gotoxy(27,17);clreol();
  gotoxy(27,18);clreol();
  gotoxy(27,19);clreol();

  if ( ESTA_BORRADO(RArticulo))
     {
     VerError(" ---- REGISTRO ELIMINADO ---- ");
     }
  else
     {
     gotoxy( 15,10); cprintf(" CODIGO :%s" ,RArticulo.codigo);
	  gotoxy( 15,11); cprintf(" GRUPO  :%d",RArticulo.grupo);
	  gotoxy( 15,12); cprintf(" DESCRIPCION :%s",RArticulo.descripcion);
	  gotoxy( 15,13); cprintf(" PROVEEDOR   :%s" ,RArticulo.proveedor);
	  gotoxy( 15,14); cprintf(" STOCK     :%3d",RArticulo.stock);
	  gotoxy( 15,15); cprintf(" STOCKMIN  :%3d" ,RArticulo.stockmin);
	  gotoxy( 15,16); cprintf(" PRECIOV   :%6d",RArticulo.preciov);
	  gotoxy( 15,17); cprintf(" PRECIOC   :%6d" ,RArticulo.precioc);
	  gotoxy( 15,18); cprintf(" FCOMPRA   :%02d/%02d/%4d",RArticulo.fcompra.dia,
	  RArticulo.fcompra.mes,RArticulo.fcompra.anio);
	  gotoxy( 15,19); cprintf(" FVENTA    :%02d/%02d/%4d" ,RArticulo.fventa.dia,
	  RArticulo.fventa.mes,RArticulo.fventa.anio);
	  textcolor(GREEN);
     }
}


/* ----------------------------------------*/
/*           Lee el siguiente registro     */
/* ----------------------------------------*/
void Siguiente ( void )
{
if ( fread(&RArticulo,sizeof(RArticulo),1,fent) == 0 )
   {
   VerError("Fin de Fichero.");
   }
}

/* --------------------------------------*/
/* Lee  registro anterior al actual      */
/* --------------------------------------*/
void Anterior( void )
{
 long pos;

 /* Obtengo la posicin del registro anterior */
  pos = ftell(fent) - (2L * sizeof(RArticulo));

 /* Si no es antes del principio de fichero */
 if (  pos >= 0 )
    {
    fseek(fent,pos,SEEK_SET);
    fread(&RArticulo,sizeof(RArticulo),1,fent);
    }
    else
    {
    VerError("Inicio del fichero");
    }
}

/* ---------------------------------------------------------------*/
/* Me situo y leo un registro determinado del fichero             */
/* ---------------------------------------------------------------*/
void Otro ( void )
{

   long new_pos;
   long max_pos;
   long num_reg;

   /* Calculo la posicin del ultimo registro */
   fseek(fent,0L,SEEK_END);
   max_pos = ftell(fent) - sizeof(RArticulo);

   do {

       gotoxy(24, 7); cprintf("                    ");
       gotoxy(15, 7); cprintf(" N Reg : ");

       // Mientra falle el scan
       while ( cscanf("%ld",&num_reg) == 0);

       /* Posicin fsica a partir del Nmero de registro */
       new_pos = ( num_reg - 1) * sizeof(RArticulo);
      }
   while ( ( new_pos < 0 ) || ( new_pos > max_pos ) );

   fseek(fent,new_pos,SEEK_SET );
   fread(&RArticulo, sizeof(RArticulo), 1, fent );

}

/* -----------------------------------------------*/
/* Me situo y leo el primer registro del fichero */
/* ----------------------------------------------*/
void Primero( void )
{

  fseek(fent,0L,SEEK_SET);
  fread(&RArticulo, sizeof(RArticulo),1, fent);

}

/* ----------------------------------------------*/
/* Me situo y leo el ultimo registro del fichero */
/* ----------------------------------------------*/
void Ultimo ( void )
{

   fseek(fent, 0L - sizeof(RArticulo),SEEK_END);
   fread(&RArticulo, sizeof(RArticulo), 1, fent);
}

/* ---------------------------------------------------------------*/
/*                  Rellena campos en el fichero                  */
/* ---------------------------------------------------------------*/

void RellenarCampos ( short modificar )
{
  // Borro los valores anterior mostrados en pantalla
  int igrupo;
  if ( !modificar )
     {
  		gotoxy(24, 8);clreol();
        gotoxy(24,10);clreol();
  		gotoxy(24,11);clreol();
  		gotoxy(29,12);clreol();
  		gotoxy(29,13);clreol();
  		gotoxy(27,14);clreol();
  		gotoxy(27,15);clreol();
  		gotoxy(27,16);clreol();
  		gotoxy(27,17);clreol();
  		gotoxy(27,18);clreol();
  		gotoxy(27,19);clreol();
      }

  textcolor(DARKGRAY);

  // Solicito Nuevos valores

  ObtenerCadenaXY(24,10,RArticulo.codigo,5, modificar);
  // Solo puede leer enteros no short
  igrupo = RArticulo.grupo;
  ObtenerNumeroXY(24,11,& igrupo,2, modificar);
  RArticulo.grupo = (short) igrupo;
  ObtenerCadenaXY(29,12, RArticulo.descripcion,29,modificar);
  ObtenerCadenaXY(29,13, RArticulo.proveedor,29, modificar );
  ObtenerNumeroXY(27,14,& RArticulo.stock,5, modificar);
  ObtenerNumeroXY(27,15,& RArticulo.stockmin,5, modificar);
  ObtenerNumeroXY(27,16,& RArticulo.preciov,6, modificar);
  ObtenerNumeroXY(27,17,& RArticulo.precioc,6, modificar);
  ObtenerFecha(27,18,& RArticulo.fcompra,modificar);
  ObtenerFecha(27,19,& RArticulo.fventa,modificar);

}


/* -------------------------------------*/
/*       Incluir un nuevo REGISTRO      */
/* -------------------------------------*/
void Nuevo ( void )
{
  int i;

  fseek(fent,0,SEEK_END);   // Me situo al final
  RellenarCampos(0);         // Solicito nuevo valores
  for (i=0;i<12;i++)
   	{
      RArticulo.ventasmes[i]=0;  // Ventas iniciales a cero
      }
  // Actualizo la Tabla de Indices
  Idx_Anotar(RArticulo.codigo,ftell(fent));

  // Grabo el registro al fichero
  fwrite(& RArticulo,sizeof(RArticulo),1,fent);
  fseek(fent,0,SEEK_CUR);   // fseek para despues poder leer sin problemas
}

/* ---------------------------------------------------------------*/
/*             Modificar registro ya existente                    */
/* ---------------------------------------------------------------*/
void Modificar ( void )
{
 long pos;
 char clave[30];


 /* Obtengo la posicin del  registro  */
 pos = ftell(fent) - ( 1 * sizeof(RArticulo));
 fseek(fent,pos,SEEK_SET);

 // Guardo la antigua clave por si cambia.
 strcpy(clave,RArticulo.codigo);

 // Muestra el antiguo valor
 RellenarCampos(1);

 // Si ha cambiado la clave
 // Actualizo la tabla de ndices.
 if ( strcmp(clave,RArticulo.codigo) != 0 )
    {
    Idx_Borrar(clave);
    Idx_Anotar(RArticulo.codigo, pos );
    }

 /* Graba el nuevo registro  */
 fwrite( &RArticulo,   sizeof(RArticulo),1,fent );
 fseek(fent,0,SEEK_CUR);
}

/* ----------------------------------------------------------------*/
/*  VENTA Solicita fecha y cantidad de unidades vendidas y actualiza */
/* ----------------------------------------------------------------*/
void Venta ( void )
{
   long pos;
   int mes;
	int unidades;

   gotoxy(51,11); cprintf("------- V E N T A -----------");
   gotoxy(51,12); cprintf(" Unidades vendidas: ");
   gotoxy(51,13); cprintf(" Fecha de venta   : ");
   gotoxy(51,14); cprintf("-----------------------------");
   ObtenerNumeroXY(70,12, & unidades,5, 0);
   // Mientra no tenga suficientes existencias
   while (unidades > RArticulo.stock)
   	{
      getch();
      VerError("Error: Las unidades superan el stock actual.");
      getch();
   	gotoxy(70,12); clreol();
      ObtenerNumeroXY(70,12, & unidades,5, 0);
   	}

   ObtenerFecha(70,13, & RArticulo.fventa,0);

   gotoxy(51,11);clreol();
   gotoxy(51,12);clreol();
   gotoxy(51,13);clreol();
   gotoxy(51,14);clreol();


   // Actualizo el registro en memoria
   RArticulo.stock = RArticulo.stock - unidades;
   mes = RArticulo.fventa.mes - 1 ;
   RArticulo.ventasmes[mes] += unidades; // Incremeta la ventas del mes

   // Grabo el registro en el fichero
   pos = ftell(fent) - sizeof(RArticulo);
   fseek(fent,pos,SEEK_SET);
   fwrite( & RArticulo,sizeof(RArticulo),1,fent);
   fseek(fent,0,SEEK_CUR);

}
/* --------------------------------------------------------------------*/
/*  Compra Solicita fecha y cantidad de unidades compradas y actualiza */
/* --------------------------------------------------------------------*/
void Compra ( void )
{
   long pos;
	int unidades;

   gotoxy(51,11); cprintf("------- C O M P R A ----------");
   gotoxy(51,12); cprintf(" Unidades Compradas: ");
   gotoxy(51,13); cprintf(" Fecha de Compra  : ");
   gotoxy(51,14); cprintf("-----------------------------");
   ObtenerNumeroXY(72,12, &unidades,5, 0);
   ObtenerFecha(70,13, & RArticulo.fcompra,0);

   gotoxy(51,11);clreol();
   gotoxy(51,12);clreol();
   gotoxy(51,13);clreol();
   gotoxy(51,14);clreol();

   // Actualizo el registro en memoria
   RArticulo.stock = RArticulo.stock + unidades;

   // Grabo el registro en el fichero
   pos = ftell(fent) - sizeof(RArticulo);
   fseek(fent,pos,SEEK_SET);
   fwrite( & RArticulo,sizeof(RArticulo),1,fent);
   fseek(fent,0,SEEK_CUR);

}

/* ------------------------------------------- */
/* Borro un registro mediante una marca lgica */
/* ------------------------------------------- */
void Eliminar (void)
	{
    char opcion;

    VerError(" Est seguro que desea eliminar este registro? (S/N):");
    opcion = (char ) getch();
    if ( toupper(opcion) == 'S')
        {
        // Elimino de la tabla de indices
        Idx_Borrar(RArticulo.codigo);
        //Copio la marca al campo codigo
        POR_BORRADO(RArticulo);
        // Actualizo el fichero
        //Me posiciono al principio del registro actual
        fseek (fent, 0 - sizeof(RArticulo),SEEK_CUR);
        fwrite(&RArticulo,sizeof(RArticulo),1,fent);
        fseek (fent,0,SEEK_CUR);
        }
   }

/* ---------------------------------------*/
/* Busca un cdigo en la tabla de indices */
/* ---------------------------------------*/

void  Buscar ()
{
  char clave[30];
  long pos;

  gotoxy(50,10); cprintf(" Cdigo a Buscar:");cscanf("%s",clave);

  // Llamo a la funcin de busqueda en la tabla
  pos = Idx_Buscar ( clave );
  if ( pos == -1 )
     {
     getch(); // Leo el salto de linea
     VerError("  Error : Clave no encontrada.  ");
     getch();
     }
  else
     {
     // Me situo en la posicin y leo el registro
     fseek(fent,pos,SEEK_SET);
     fread(&RArticulo,sizeof(RArticulo),1,fent);
     }
  gotoxy(50,10); clreol(); // Borro el mensaje
}



/* ---------------------------------------------------------------*/
/* Muestra por pantalla el Submen de las opciones de los listados  */
/* ---------------------------------------------------------------*/
void Listados(void)
{
 char opcionL;
 long pos_old;
  /* Guardo la posicin actual */
  pos_old = ftell(fent);
  clrscr();
  VerMenuListados();
  opcionL = LeerOpcion(73,24,"IESTV");
  while (opcionL != 'T')
    {
    switch ( opcionL ) {
      case 'I': List_Total(fent);
                break;
      case 'S': List_Stock_Minimo(fent);
                break;
      case 'V': List_Venta_Mensual(fent);
                break;
      case 'E': List_Periodo_Estival(fent);

      }
      VerMenuListados();
    opcionL = LeerOpcion(73,24,"IESTV");
 }
  clrscr();
   /* Recupero la posicin antigua y vuelvo a pintar el menu y el registro */
 fseek(fent,pos_old-sizeof(RArticulo),SEEK_SET);
 clrscr();
 Siguiente();
 VerMenu();
 VerCampos();
}


/* -----------------------------------------------------------------------*/
/*                           PROGRAMA PRINCIPAL                           */
/*  Abre el fichero, Inicializa la tabla de indices,
     muestra el primer registro y entra el ciclo del menu */
/* -----------------------------------------------------------------------*/

int main()
{
  char opcion;
  int x = 54;  // Columna de la pantalla
  int y = 24;  // Fila de la pantalla

  // Dos listas: una completa y otra limitada cuando el registro est borrado
  char * ListaOpciones[2] ={"SAOPUBVCNMETL","SAOPUBNTL"};


  fent = fopen("ARTICULOS.DAT","rb+");

  if ( fent == NULL )
     {
     // Termina el programa
     perror("fopen");
     exit(1);
     }

  Idx_InitTabla(fent); // Creo la tabla de indices.

  /*  Muestro el menu y el primer registro      */
  clrscr();
  VerMenu();
  Siguiente();
  VerCampos();

  // Si el registro no est borrado
  if ( !ESTA_BORRADO(RArticulo) )
     {
     opcion = LeerOpcion(x,y,ListaOpciones[0]);
     }
  else
     {
     opcion = LeerOpcion(x,y,ListaOpciones[1]);
     }

  while ( opcion !='T')
    {
    switch ( opcion ) {
      case 'S': Siguiente ();
                break;
      case 'A': Anterior ();
                break;
      case 'O': Otro ();
		          break;
      case 'P': Primero();
                break;
      case 'U': Ultimo();
                break;
      case 'V': Venta();
                break;
      case 'C': Compra();
                break;
      case 'N': Nuevo();
                break;
      case 'M': Modificar();
                break;
      case 'E': Eliminar();
                break;
      case 'B': Buscar();
                break;
      case 'L': Listados ();
      			 break;
      }

      VerCampos();

      // Si el registro no est Borrado
      if ( RArticulo.grupo != 0)
   	  {
	     opcion = LeerOpcion(x,y,ListaOpciones[0]);
	     }
	  else
   	  {
	     opcion = LeerOpcion(x,y,ListaOpciones[1]);
   	  }
    }

 fclose(fent);

}
